/*
 * SWE Ereigniskalender - Version 2
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * 
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weißenfelser Straße 67
 * 04229 Leipzig
 * Phone: +49-341-49067-0
 * Fax: +49-341-49067-15
 * E-Mail: info@bitctrl.de
 */

package de.bsvrz.vew.ereigniskal.module;

import java.util.Comparator;

final class ZustandsWechselComparator implements Comparator<EreignisZustandsWechsel> {

    @Override
    public int compare(EreignisZustandsWechsel o1, EreignisZustandsWechsel o2) {
        int sortResult = Long.compare(o1.getZeitpunktMillis(), o2.getZeitpunktMillis());
        if (sortResult == 0) {
            sortResult = Integer.compare(ereignisGueltigkeitsBewertung(o1), ereignisGueltigkeitsBewertung(o2));
        }
        if (sortResult == 0) {
            sortResult = o1.getEreignis().getName().compareToIgnoreCase(o2.getEreignis().getName());
        }
        return sortResult;
    }

    private int ereignisGueltigkeitsBewertung(EreignisZustandsWechsel wechsel) {
        int bewertung = 0;
        if (wechsel.getZeitlichGueltig()) {
            bewertung += 1;
        }
        if (wechsel.getVerkehrlichGueltig()) {
            bewertung += 2;
        }
        return bewertung;
    }
}